//封装
/********** - H5+功能封装 Start- *******************************************************************************************************************/
//******--1. H5+ 页面过渡封装 S  pageTransition(href);
mui.plusReady(function() {})
var isFirst = true;
var waiting = null;
var pageMove = function(href) {
    if(!mui.os.plus) {
        location.href = href;
        return;
    }
    var webview = plus.webview.create(href, href, {
        popGesture: "close"
    }, {});
    webview.addEventListener("titleUpdate", function() {
        if(mui.os.plus) {
            waiting.close(); //关闭缓冲图
        }
        setTimeout(function() {
            webview.show('pop-in', 250);
        }, 10)
    });
};
var pageTransition = function(href) {
    if(isFirst) {
        if(mui.os.plus) {
            waiting = plus.nativeUI.showWaiting(); //开启缓冲图
        }
        isFirst = false;
        setTimeout(function() {
            isFirst = true;
        }, 500)
        pageMove(href);
    }
};
//******--1. H5+ 页面过渡封装 E

//******--2. 选择相册 S   galleryImg(callback);
var galleryImg = function(callback) {
    plus.gallery.pick(function(a) {
        plus.io.resolveLocalFileSystemURL(a, function(entry) {
            var s = entry.toLocalURL() + "?version=" + new Date().getTime();
            callback(s);
        }, function(e) {
            console.log("读取拍照文件错误：" + e.message);
        });
    }, function(e) {
        mui.toast('取消选择', {
            duration: 2000,
            type: 'div'
        })
        console.log('取消选择');
    }, {
        filter: 'image'
    })
};
//******--2. 选择相册 E

//******--3. 拍照 S  cameraImg(callback);
var cameraImg = function(callback) {
    var cmr = plus.camera.getCamera();
    //  var res = cmr.supportedImageResolutions[0]; //大小
    //  var fmt = cmr.supportedImageFormats[0]; //jpg
    cmr.captureImage(function(e) {
            plus.io.resolveLocalFileSystemURL(e, function(entry) {
                var s = entry.toLocalURL() + "?version=" + new Date().getTime();
                console.log(s)
                callback(s);
            }, function(e) {
                console.log("读取拍照文件错误：" + e.message);
            });
        },
        function(error) {
            mui.toast('取消拍照', {
                duration: 2000,
                type: 'div'
            })
            console.log('取消拍照');
        }, {
            format: 'jpg'
        }
    );
};
//******--3. 拍照 E

//******--4. 摄像 S  videoCapture(callback);   未完成
var videoCapture = function(callback) {
    var cmr = plus.camera.getCamera();
    var res = cmr.supportedVideoResolutions[0];
    var fmt = cmr.supportedVideoFormats[0];
    cmr.startVideoCapture(function(path) {
            alert("Capture video success: " + path);
            callback(callback);
        },
        function(error) {
            alert("Capture video failed: " + error.message);
        }, {
            resolution: res,
            format: fmt
        }
    );
};
//******--4. 摄像 E

//******--5. 弹出系统选择按钮框 S  actionSheet(title, cancel, btns,callback);
var actionSheet = function(title, cancel, btns, callback) {
    if(arguments.length != 4) {
        console.error('传入参数错误：1. title标题，2.底部按钮名称(取消)，3.按钮数组对象[{title:"1"},{title:"2"}],4.回调函数');
        return
    }
    if(!btns[0].title) {
        console.error('按钮数组对象错误：样式 [{title:"1"},{title:"2"}]');
        return
    }
    if(!cancel) {
        cancel = "取消";
    }
    // 弹出系统选择按钮框
    plus.nativeUI.actionSheet({
        title: title,
        cancel: cancel,
        buttons: btns
    }, function(e) {
        callback(e.index);
    });
};
//******--5. 弹出系统选择按钮框 E

//******--6. 压缩图片 S  未测试
var resizeImage = function(src, callback) {
    plus.zip.compressImage({
            src: src,
            dst: '_doc/a.jpg',
            overwrite: true,
            width: '270px', //这里指定了宽度，同样可以修改
            format: 'jpg',
            quality: 100 //图片质量不再修改，以免失真
        },
        function(e) {
            callback(e.target);
            //上传图片, e.target存的是本地路径！
        },
        function(err) {
            mui.toast('未知错误', {
                duration: 2000,
                type: 'div'
            })
        }
    );
};
//******--6. 压缩图片 E

//******--7. 上传图片 S  未测试
var uploadImg = function(src) {
    var task = plus.uploader.createUpload(ajaxUrl, {
        method: 'post',
        blocksize: 204800,
        timeout: 10
    });

    task.addFile(src, {
        key: 'headImg'
    });
    task.addData('type', 'uploadImg');
    task.addData('userId', '');
    task.addEventListener('statechanged', stateChanged, false);
    task.start();

    function stateChanged(upload, status) {
        if(upload.state == 4 && status == 200) {
            plus.uploader.clear(); //清除上传
            console.log(upload.responseText); //服务器返回存在这里
        }
    }
};
//******--7. 上传图片 E

//******--8. 录制语音 S
var audioRecording = function(elem, callback) {
    mui.init({
        gestureConfig: {
            tap: true, //默认为true
            doubletap: true, //默认为false
            longtap: true, //默认为false
            swipe: true, //默认为true
            drag: true, //默认为true
            hold: true, //默认为false，不监听
            release: true //默认为false，不监听
        }
    });
    var r = null,
        end = null,
        start = null,
        audiourl = "",
        audiolength = 0,
        recordCancel = false;
    elem.on('hold', function() {
        recordCancel = false;
        start = (new Date()).valueOf();
        r = plus.audio.getRecorder();
        if(r == null) {
            plus.nativeUI.toast("Device not ready!");
            return;
        }
        var fileName = "/audio/" + (new Date()).valueOf() + ".amr";
        r.record({
            filename: "_doc" + fileName
        }, function(path) {
            audiourl = plus.io.convertLocalFileSystemURL(path);
            if(!recordCancel) {
                return
            };
            callback({
                length: audiolength,
                path: audiourl
            });
        }, function(e) {
            r.stop();
            plus.nativeUI.toast("录音时出现异常: " + e.message);
        });
    }).on('release', function() {
        end = (new Date()).valueOf();
        r.stop();
        //计算录音长度
        audiolength = end - start;
        if(audiolength < 800) {
            plus.nativeUI.toast('语音时间太短');
            recordCancel = false;
        } else {
            recordCancel = true;
        }
    });
}
//******--8. 录制语音 E

//******--9. 播放语音 S
var pl = null;
var playAudio = function(audiokey, callback) {
    if(plus.audio == undefined) {
        plus.nativeUI.toast("Device not ready!");
        return
    }
    if(pl) {
        pl.stop();
    }
    pl = plus.audio.createPlayer(audiokey);
    pl.play(function() {
        pl = null;
        callback();
    }, function(e) {
        plus.nativeUI.toast("播放错误: " + e.message);
    });
}
//******--9. 播放语音 E

//******--1. XXXXXXXXXXXX S
//******--1. XXXXXXXXXXXX E

//******--1. XXXXXXXXXXXX S
//******--1. XXXXXXXXXXXX E

/********** - H5+功能封装 End- *******************************************************************************************************************/

/********** - 其他JS功能封装 Start- *****************************************************************************************************************/
//******1. 获取URL中参数 S   getUrlParam(name)
var getUrlParam = function(name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
    var r = window.location.search.substr(1).match(reg); //匹配目标参数
    if(r != null) return unescape(r[2]);
    return null; //返回参数值
};
//******1. 获取URL中参数 E

//******2. 安卓下样式修改 S
if(mui.os.android) {
    $('.only-android').css({
        "position": "relative",
        "bottom": "-0.08rem"
    })
};
//******2. 安卓下样式修改 E

//******3. textarea输入框阻止默认滑动 S
window.addEventListener('touchmove', function(e) {
    var target = e.target;
    if(target && target.tagName === 'TEXTAREA' && target.scrollHeight > target.clientHeight) { //textarea阻止冒泡
        e.stopPropagation();
    }
}, true);
//******3. textarea输入框阻止默认滑动 E

//******4. 压缩图片 S  resizeImg(ele,callback,1)  ele为input元素(原生) callback 回调函数  1为压缩比例 默认0.8
var resizeImg = function() {
    var ele = arguments[0],callback = arguments[1],size=arguments[2];
    if(!size){
        size = 0.8;
    }
    if(size>1){
        size = 1;
    }
    var files = ele.files[0];
    var elem = $(ele);
    if(!ele.files.length) {
        return
    };
    if(ele.files.length > 1) {
        mui.alert("只允许上传一张图片!", '提示', '确定', function() {}, 'div');
        return;
    }
    if(!/image\/\w+/.test(files.type)) {
        mui.alert("请选择图片格式！", '提示', '确定', function() {}, 'div');
        return
    }
    var reader = new FileReader();
    reader.readAsDataURL(files);
    reader.onload = function() {
        var newimg = new Image();
        var dataResult = this.result;
        //newimg.setAttribute('crossorigin','anonymous'); 跨域
        newimg.quality = 1.0;
        console.log(dataResult.length)
        newimg.src = dataResult; //data:base64
        newimg.onload = function() {
            var imgData = getBase64Image(newimg,size);
            if(dataResult.length<imgData.length){
                imgData = dataResult;
            }
            callback(imgData);
        }
    };
};
//将图片压缩转成base64 
var getBase64Image = function(img,size) {
    var canvas = document.createElement("canvas");
    var imgW = img.width-0,
        imgH = img.height-0;
    canvas.width = imgW*size; //设置绘图大小
    canvas.height = imgH*size;
    var ctx = canvas.getContext("2d");
    ctx.drawImage(img, 0, 0, canvas.width, canvas.height);
    var basePath = canvas.toDataURL('image/png');
    console.log(basePath.length)
    //basePath.replace("data:image/png;base64,", "");
    return basePath;
};
//******4. 压缩图片 E

//******5. 计算元素距离文档顶部距离 S
var getTop = function(elem) {
    var sum = elem.offsetTop;
    while(elem.offsetParent) {
        sum += elem.offsetParent.offsetTop;
        elem = elem.offsetParent;
    }
    return sum;
};
//******5. 计算元素距离文档顶部距离 E

//******6. 时间戳 转换日期yyyy年M月d日 h:m:s  S    var time=new Date(parseInt(1420184730s) * 1000).format('yyyy年M月d日');
Date.prototype.format = function(fmt) {
    var o = {
        "M+": this.getMonth() + 1,
        "d+": this.getDate(),
        "h+": this.getHours(),
        "m+": this.getMinutes(),
        "s+": this.getSeconds(),
        "q+": Math.floor((this.getMonth() + 3) / 3),
        "S": this.getMilliseconds()
    };
    if(/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for(var k in o) {
        if(new RegExp("(" + k + ")").test(fmt))
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k] < 10 ? "0" + o[k] : o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    }
    return fmt;
};
//******6. 时间戳 转换日期yyyy年M月d日 h:m:s E

//******7. 上拉加载 下拉刷新 S  scrollUpDown(elem,callback);
var scrollUpDown = function(elem, callback) {
    //elem为滑动的$('.mui-scroll')元素  callback回调函数 index  -2  -1  0  1  2 五个状态
    var scrH = elem.height(),
        scrPH = elem.parent().height(),
        scrT = elem.css('transform').split(/,/)[5].replace(/\)$/, "") - 0;
    var index = 0;
    var isDown = false,
        isUp = false; //状态
    //加载
    elem.parent().on('drag', '.mui-scroll', function() {
        scrT = $('.mui-scroll').css('transform').split(/,/)[5].replace(/\)$/, "") - 0;
        if(scrT > 0) {
            if(scrT > 20) {
                if(!isUp) {
                    isUp = true;
                    index = -1;
                }
            } else {
                index = 0;
                if(isUp) {
                    isUp = false;
                }
            }
        } else if(scrT < 0) {
            if(-scrT > scrH - scrPH + 15) {
                if(!isDown) {
                    isDown = true;
                    index = 1;
                }
            } else {
                index = 0;
                if(isDown) {
                    isDown = false;
                }
            }
        }
        callback(index);
    })
    //上拉加载
    elem.parent().on('dragend', '.mui-scroll', function() {
        scrH = $('.mui-scroll').height();
        scrPH = $('.mui-scroll-wrapper').height();
        if(isDown) {
            index = 2;
            isDown = false;
        } else if(isUp) {
            index = -2;
            isUp = false;
        }
        callback(index);
    })
};
//******7. 上拉加载 下拉刷新 E

//******8. 获取本地cookie值 S   getCookie(name)
var getCookie = function(name) {
    var arr, reg = new RegExp("(^| )" + name + "=([^;]*)(;|$)");
    if(arr = document.cookie.match(reg)) {
        return unescape(arr[2]);
    } else {
        return null;
    }
};
//******8. 获取本地cookie值 E

//******9. 判断访问终端 S
var browserType = function() {
    var u = navigator.userAgent,
                  app = navigator.appVersion; 
    return {
        trident: u.indexOf("Trident") > -1, //IE内核
        presto: u.indexOf("Presto") > -1, //opera内核
        webKit: u.indexOf('AppleWebKit') > -1, //苹果、谷歌内核
        gecko: u.indexOf('Gecko') > -1 && u.indexOf('KHTML') == -1, //火狐内核
        mobile: !!u.match(/AppleWebKit.*Mobile.*/), //是否为移动终端
        ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), //ios终端
        android: u.indexOf('Android') > -1 || u.indexOf('Adr') > -1, //android终端
        iPhone: u.indexOf('iPhone') > -1, //是否为iPhone或者QQHD浏览器
        iPad: u.indexOf('iPad') > -1, //是否iPad
        webApp: u.indexOf('Safari') == -1, //是否web应该程序，没有头部与底部
        weixin: u.indexOf('MicroMessenger') > -1, //是否微信 （2015-01-22新增）
        qq: u.match(/\sQQ/i) == " qq", //是否QQ
        language: (navigator.browserLanguage || navigator.language).toLowerCase() //语言
    };   
}
//******9. 判断访问终端 E



//******10. 输入框呼出输入法时 改输入框显示在可视窗口内 S     elem为$(input)输入框元素 btm为距离底部高度(计算出来 底部浮动元素高度+10)
var inputOnresize = function(elem, btm) {
    var viewH1 = document.documentElement.clientHeight; //获取 除去输入法的可视高度
    var viewH = 0;
    elem.focus(function() {
        var scrolltop = getTop(this);
        onresize = function() {
            viewH = document.documentElement.clientHeight; //获取可视高度 如果发生了改变
            if(viewH1 != viewH && viewH < scrolltop + btm) {
                mui('.mui-scroll-wrapper').scroll().scrollTo(0, (viewH - btm - scrolltop), 100);
                return
            }
        }
    });
}
//******10. 输入框呼出输入法时 改输入框显示在可视窗口内 E     elem为$(input)输入框元素 btm为距离底部高度(计算出来 底部浮动元素高度+10)

//******2. XXXXXXXX S
//******2. XXXXXXXX E

/********** - 其他JS功能封装 End- *****************************************************************************************************************/

//$('body').on('tap','.tie-attention span',function(e){
//  e.preventDefault();
//  e.stopPropagation();
//  $(this).css('backgroundColor','#FF00CE')
//})

//$('body').append('<div class="ys-modal-loading"><div class="mui-spinner"></div></div>');//添加缓冲动画